<?php
namespace Teknisa\PLA\Modules\Medicao\Controllers;
use Zeedhi\Framework\DTO;
use Setforms2\Shared\ORM\DateTime;

class Pla1001RelatorioDeEfetivos extends \Zeedhi\Framework\Controller\Report {
    protected $qr2Strategy;
    protected $environment;
    protected $entityManager;
    
    public function __construct($reportService, $birtStrategy, $environment, $entityManager, $util) {
        $this->birtStrategy     = $birtStrategy;
        $this->reportService	= $reportService;
        $this->environment      = $environment;
        $this->entityManager    = $entityManager;
        $this->util             = $util;
    }
    
    protected $reportMapping = array (
        'PLA01000' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array (
                'CDFILIAL'       => 'P_CDFILIAL',
                'VALOR_NA_LISTA' => 'P_SERVICOS',
                'DATAINI'        => 'P_DTINICIAL',
                'DATAFIN'        => 'P_DTFINAL',
                'NRORG'          => 'P_NRORG',
            ),
        ),
        'PLA01001' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array(
                'DATAINI'        => 'P_DTPERIINI',
                'DATAFIN'        => 'P_DTPERIFIN',
                'CDFILIAL'       => 'P_CDFILIAL',
                'DATAINI'        => 'P_DTINICIAL',
                'DATAFIN'        => 'P_DTFINAL',
                'VALOR_NA_LISTA' => 'P_SERVICOS',
                'NRORG'          => 'P_NRORG',
            ),
        ),
        'PLA01002' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array(
                'DATAINI'        => 'P_DTPERIINI',
                'DATAFIN'        => 'P_DTPERIFIN',
                'CDFILIAL'       => 'P_CDFILIAL',
                'DATAINI'        => 'P_DTINICIAL',
                'DATAFIN'        => 'P_DTFINAL',
                'VALOR_NA_LISTA' => 'P_SERVICOS',
                'NRORG'          => 'P_NRORG',
            ),
        ),
        'PLA01003' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array(
                'DATAINI'        => 'P_DTPERIINI',
                'DATAFIN'        => 'P_DTPERIFIN',
                'CDFILIAL'       => 'P_CDFILIAL',
                'DATAINI'        => 'P_DTINICIAL',
                'DATAFIN'        => 'P_DTFINAL',
                'VALOR_NA_LISTA' => 'P_SERVICOS',
                'NRORG'          => 'P_NRORG',
                'CDPICTPRAT' =>  'P_CDPICTPRAT',
            ),
        ),
        'PLA01004' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array(
                'DATAINI'        => 'P_DTPERIINI',
                'DATAFIN'        => 'P_DTPERIFIN',
                'CDFILIAL'       => 'P_CDFILIAL',
                'DATAINI'        => 'P_DTINICIAL',
                'DATAFIN'        => 'P_DTFINAL',
                'VALOR_NA_LISTA' => 'P_SERVICOS',
                'NRORG'          => 'P_NRORG',
                'CDPICTPRAT' =>  'P_CDPICTPRAT',
            ),
        ),
        'PLA01005' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array(
                'DATAINI'        => 'P_DTPERIINI',
                'DATAFIN'        => 'P_DTPERIFIN',
                'CDFILIAL'       => 'P_CDFILIAL',
                'DATAINI'        => 'P_DTINICIAL',
                'DATAFIN'        => 'P_DTFINAL',
                'VALOR_NA_LISTA' => 'P_SERVICOS',
                'NRORG'          => 'P_NRORG',
                'CDPICTPRAT' =>  'P_CDPICTPRAT',
            ),
        ),
        'PLA01006' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array(
                'DATAINI'        => 'P_DTPERIINI',
                'DATAFIN'        => 'P_DTPERIFIN',
                'CDFILIAL'       => 'P_CDFILIAL',
                'DATAINI'        => 'P_DTINICIAL',
                'DATAFIN'        => 'P_DTFINAL',
                'VALOR_NA_LISTA' => 'P_SERVICOS',
                'NRORG'          => 'P_NRORG',
            ),
        ),
        'PLA01007' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array(
                'DATAINI'        => 'P_DTINICIAL',
                'DATAFIN'        => 'P_DTFINAL',
                'CDFILIAL'       => 'P_CDFILIAL',
                'VALOR_NA_LISTA' => 'P_SERVICOS',
                'NRORG'          => 'P_NRORG',
            ),
        ),
        'PLA01008' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array(
                'DATAINI'        => 'P_DTINICIAL',
                'DATAFIN'        => 'P_DTFINAL',
                'CDFILIAL'       => 'P_CDFILIAL',
                'VALOR_NA_LISTA' => 'P_SERVICOS',
                'NRORG'          => 'P_NRORG',
            ),
        ),
    );
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
    	$row = $request->getRow();
    	$this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
    	$row['NRORG'] = $this->environment->getNrOrg();
    	if($row['VALOR_NA_LISTA'] == 'T'){
            $row['VALOR_NA_LISTA'] = implode('_', $this->getServicos($row));
    	}
    	$listaServico = $row['VALOR_NA_LISTA'];
    	$row['VALOR_NA_LISTA'] = $this->util->criarListaValores($listaServico);
    }
    
    private function getServicos($row) {
        $query = "SELECT
                        S.CDSERVFILI
                    FROM
                        SERVICO    S,
                        FILIOPER   F
                    WHERE
                        S.CDFILIAL = :CDFILIAL
                        AND ( F.CDOPERADOR = :CDOPERADOR )
                        AND ( F.CDFILIAL = S.CDFILIAL )
                        AND ( S.NRORG = :NRORG )";
        $params = array(
            'CDFILIAL'   => $row['CDFILIAL'],
            'CDOPERADOR' => $this->environment->getCdOperador(),
            'NRORG'      => $this->environment->getNrOrg()
        );
        
        $std = $this->entityManager->getConnection()->prepare($query);
        $std->execute($params);
        return array_column($std->fetchAll(), 'CDSERVFILI');
    }
}